=== debian/changelog ===
doxygen (1.8.17-0ubuntu2+10.0trisquel2) nabia; urgency=medium

  * Replace references to nonfree browsers to freedom respecting ones

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 26 Feb 2021 18:00:52 +0000
