## doxygen 1.8.18

=== debian/changelog ===
doxygen (1.8.18-1ubuntu3) groovy; urgency=medium

  * Make the autopkgtest also depend on build-essential.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 05 Aug 2020 12:26:32 +0300

doxygen (1.8.18-1ubuntu2) groovy; urgency=medium

  * Update the autopkgtest to work with CMake port of json-c.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 04 Aug 2020 21:47:28 +0300

doxygen (1.8.18-1ubuntu1) groovy; urgency=medium

  * Resynchronize on Debian, remaining change
  * debian/control:
    - build with llvm10

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 04 Aug 2020 17:38:27 +0200

doxygen (1.8.18-1) unstable; urgency=medium

  * Upload to unstable.

 -- Paolo Greppi <paolo.greppi@libpf.com>  Sat, 25 Jul 2020 06:47:33 +0200

doxygen (1.8.18-1~exp1) experimental; urgency=medium

  * doxygen 1.8.18 release.

 -- Paolo Greppi <paolo.greppi@libpf.com>  Fri, 22 May 2020 09:32:34 +0200

doxygen (1.8.17-1) unstable; urgency=medium

  * Upload to unstable.
  * Make examples reproducible by stripping metadata from pdf files.
  * Dropping unused Build-Depends on yui-compressor also allows to bootstrap
    doxygen without needing Java. Closes: #879695.
  * Make the GNU_BUILD_ID reproducible

 -- Paolo Greppi <paolo.greppi@libpf.com>  Thu, 30 Apr 2020 19:36:59 +0200

doxygen (1.8.17-1~exp2) experimental; urgency=medium

  * Fix sass compilation error. Closes: #954677.

 -- Paolo Greppi <paolo.greppi@libpf.com>  Tue, 07 Apr 2020 12:02:12 +0200

doxygen (1.8.17-1~exp1) experimental; urgency=medium

  [ Samuel Thibault ]
  * Drop unused build dependency. Closes: #947897.

  [ Paolo Greppi ]
  * doxygen 1.8.17 release.
  * Bump standards version to 4.5.0: No changes needed.
  * Make doxygen_manual.pdf build reproducibly with cmake.
  * Make the changelog reproducible.
  * Make the manpages reproducible when the timezone changes.
  * Import upstream patch to use eps2eps rather than ps2epsi.

 -- Paolo Greppi <paolo.greppi@libpf.com>  Sat, 01 Feb 2020 18:32:03 +0100
