=== debian/tests/control ===
Tests: run
Depends: apt:native,
         build-essential,
         cmake:native,
         doxygen,
         dpkg-dev,
         graphviz:native
